import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Startklass fr skalgoritmen. 
 * 
 * SearchInterface kan anropas med tre eller fem parametrar. 
 * De tv frsta parametrarna anger namnet p er skklass respektive kartan som ska skas. 
 * Parameter tre anger skmetod, B, D, A eller G vilket motsvarar bredden frst, djupet frst, A* respektive Greedy Search.
 * 
 * Parameter fyra och fem anger start och ml fr skningen. Om dessa utelmnas kommer programmet 
 * att frga efter dem.  
 * 
 * Exempel: java SearchInterface MySearcher umea_map.xml B Teg Begbilar
 * 
 * @author billing
 */
public class SearchInterface {
	
	public static void main(String[] args) {
		BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
		
		try {
			if (args.length < 3) {
				System.err.println("Skklass, karta och skmetod mste anges.");
			} else {
				Class c = Class.forName(args[0]); // Importerar skklassen
				MapSearcher searcher = (MapSearcher)c.newInstance(); // Instansierar
				searcher.setMap(new File(args[1])); // Anger kartan
				
				String from;
				String to;
				if (args.length > 3) {
					from=args[3];
				} else {
					System.out.print("Ange startnod: ");
					from = stdin.readLine();
				}
				if (args.length > 4) {
					to=args[4];
				} else {
					System.out.print("Ange mlnod: ");
					to = stdin.readLine();
				}
				
				System.out.print(args[0]+" ");
				if (args[2].equals("B")) {
					System.out.print("sker med bredden frst... ");
					System.out.println("klar.\n"+searcher.breadthFirst(from,to)); 
				} else if (args[2].equals("D")) {
					System.out.print("sker med djupet frst... ");
					System.out.println("klar.\n"+searcher.depthFirst(from,to)); 
				} else if (args[2].equals("A")) {
					System.out.print("sker med A* (kortaste vgen)... ");
					System.out.println("klar.\n"+searcher.aStar(from,to,false)); 
					System.out.print("sker med A* (snabbaste vgen)... ");
					System.out.println("klar.\n"+searcher.aStar(from,to,true)); 
				} else if (args[2].equals("G")) {
					System.out.print("sker med Greedy Search... ");
					System.out.println("klar.\n"+searcher.greedySearch(from,to)); 
				}
				
				
			}
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}
